#!/usr/bin/env python





########################################################################
# importing depending modules
import pdb,sys,os,stat,time,shutil
import subprocess
import multiprocessing
import threading

p_version=sys.version_info[0]

python=sys.executable

# checking the version of python
if p_version<=2:
	try:
		import Tkinter
		from Tkinter import *
		from tkFileDialog import askopenfilename
	except:
		print ("Please install the Tkinter module first!")
		time.sleep(10)
		sys.exit(0)
		
elif p_version>=3:
	try:
		import tkinter
		from tkinter import *
		from tkinter.filedialog import askopenfilename
	except:
		print ("please install the tkinter module first!")
		time.sleep(10)
		sys.exit(0)
	

import webbrowser
########################################################################




########################################################################

########################################################################

class App:
	def __init__(self,master):
		
		###zero frame##################################################
		fheader=Frame(master)
		self.label_title=Label(fheader,text="Welcome to use SIOMICS", fg="black",font="Helvetica 16 bold italic")
		self.label_id=Label(fheader,text="Data Integration and Knowledge Discovery Lab\n University of Central Florida", fg="black",font="Times 10 bold italic")
		
		#pack manager
		self.label_title.pack(padx=6)
		self.label_id.pack(padx=6)
		fheader.pack(fill="x",pady=4)
		
		
		
		sep0=Frame(master,height=2,bd=1,relief=SUNKEN)
		sep0.pack(fill="x",pady=4)
		
		##first frame###################################################
		##file opener---------------------------------------------------
		fop=Frame(master)
		self.button1=Button(fop,text="Choose your input sequence (-i)",fg="black",command=self.load_file,width=30)
		self.v=StringVar()
		self.label1=Label(fop,textvariable=self.v,bg="gray",width=30)
		self.vn=StringVar()
		self.label2=Label(fop,textvariable=self.vn,bg="gray",width=30)
		self.button1.pack(side=LEFT,padx=6)
		self.label1.pack(side=LEFT,padx=20)
		self.label2.pack(side=LEFT,padx=20)
		fop.pack(fill="x",pady=6)
		
		
		
		##second Frame
		## paramters----------------------------------------
		sep=Frame(master,height=2,bd=1,relief=SUNKEN)
		sep.pack(fill="x",pady=4)
		pt=Frame(master)
		self.label_p=Label(pt,text="Parameters",fg="black",font=8)
		##grid manager
		self.label_p.pack(side="left",padx=6,pady=6)
		pt.pack(fill="x")

		
		##Third Frame###################################################
		## inputting parameters-----------------------------------------
		sf=Frame(master,bg="gray",borderwidth=1,relief=SUNKEN,pady=6)
		wid=50
		##--motif width--------------------------------------
		self.v1=StringVar()
		self.label_w=Label(sf,textvariable=self.v1,bg="gray",width=20)
		self.v1.set("Width of motifs (-w)")
		self.entry_w=Entry(sf)
		self.label_w2=Label(sf,text="(e.g. 8 --motif with length 8)",width=wid)
		#grid manager
		self.label_w.grid(row=1,column=0,padx=6)
		self.entry_w.grid(row=1,column=1,padx=6)
		self.label_w2.grid(row=1,column=2,padx=6)
		
		##--max # of motifs-----------------------------------
		self.label_m=Label(sf,text="Maximal number of output motifs (-m)",bg="gray",width=30)
		self.entry_m=Entry(sf)
		self.label_m2=Label(sf,text="(e.g. 100 --consider top 100 motifs)",width=wid)
		#grid manager
		self.label_m.grid(row=2,column=0,padx=6,pady=2)
		self.entry_m.grid(row=2,column=1,padx=6,pady=2)
		self.label_m2.grid(row=2,column=2,padx=6,pady=2)

		
		##--significance cutoffs-------------------------------
		self.label_c=Label(sf,text="Significance level (-c)",bg="gray",width=30)
		self.entry_c=Entry(sf)
		self.label_c2=Label(sf,text="(e.g. 0.01--corrected p-value cut 0.01)",width=wid)
		#grid manager
		self.label_c.grid(row=3,column=0,padx=6,pady=2)
		self.entry_c.grid(row=3,column=1,padx=6,pady=2)
		self.label_c2.grid(row=3,column=2,padx=6,pady=2)
		
		##--support value---------------------------------------
		self.label_s=Label(sf,text="Support value for pattern mining (-s)", bg="gray",width=30)
		self.entry_s=Entry(sf)
		self.label_s2=Label(sf,text="(e.g. 1% (2000*1%=20),it need to be Integer--Motif combination\n co-occur at least 20 times(1%) to be discovered)", width=wid)
		#grid manager
		self.label_s.grid(row=4,column=0,padx=6,pady=2)
		self.entry_s.grid(row=4,column=1,padx=6,pady=2)
		self.label_s2.grid(row=4,column=2,padx=6,pady=2)
		
		
		##--max iterations-----------------------------------------
		self.label_r=Label(sf,text="Maximal Iterations (-r)" ,bg="gray",width=30)
		self.entry_r=Entry(sf)
		self.label_r2=Label(sf,text="(e.g. 20--The program will run 20 iterations at most)",width=wid)
		#grid manager
		self.label_r.grid(row=5,column=0,padx=6,pady=2)
		self.entry_r.grid(row=5,column=1,padx=6,pady=2)
		self.label_r2.grid(row=5,column=2,padx=6,pady=2)
		
		##--output direcotry----------------------------------------
		self.label_o=Label(sf,text="Output (-o)", bg="gray", width=30)
		self.entry_o=Entry(sf)
		self.label_o2=Label(sf,text="(e.g. output-- Results will be put under given folder 'output')", width=wid)
		
		#grid manager
		self.label_o.grid(row=6,column=0,padx=6,pady=2)
		self.entry_o.grid(row=6,column=1,padx=6,pady=2)
		self.label_o2.grid(row=6,column=2,padx=6,pady=2)
		
		##
		sf.pack(fill="x")
		
		
		##Fourth Frame#################################################
		##--run---------------------------------------------------
		sep2=Frame(master,height=2,bd=1,relief=SUNKEN)
		sep2.pack(fill="x",pady=4)
		fhelp=Frame(master)
		go_help=Button(fhelp,text="Go Help!",command=self.openpage)
		go_run=Button(fhelp,text="Run!",command=self.run)
		self.v_end=StringVar()
		self.label_ending=Label(fhelp,textvariable=self.v_end,width=wid)
		##pack manager
		go_help.pack(side="left",padx=6,pady=2)
		go_run.pack(side="left",padx=6,pady=2)
		self.label_ending.pack(side="left",padx=6,pady=2)
		
		
		fhelp.pack(fill="x")
		
	##file opener function
	def load_file(self):
		self.fileName=askopenfilename()
		if self.fileName!="":
			self.FN=self.fileName.split("/")[-1]
			self.v.set(self.FN)
			self.count_gene()
			self.label_ending.update_idletasks()
	def count_gene(self):
		f=open(self.fileName,'r')
		lf=f.readlines()
		f.close()
		lf="".join(lf)
		lf=lf.split(">")[1:]
		#pdb.set_trace()
		self.vn.set("# of input sequences: "+str(len(lf)))
		
	def openpage(self):
		webbrowser.open_new("http://www.cs.ucf.edu/~xiaoman/SIOMICS/man.html")
		
	def run(self):
		self.w=self.entry_w.get()
		self.m=self.entry_m.get()
		self.c=self.entry_c.get()
		self.s=self.entry_s.get()
		self.r=self.entry_r.get()
		self.o=self.entry_o.get()
		flag=self.check_run()
		if flag:
			#self.show_run()
			self.p=threading.Thread(target=self.trun)
			self.p.start()
			
	def rename_output(self,o):
		i=1
		while(os.path.exists(o+"_"+str(i))==True):
			i+=1
		o=o+"_"+str(i)
		return o 
	
	def trun(self):
		self.v_end.set("Running...")
		self.label_ending.update_idletasks()
		os.system(python+' SIOMICS.py -i "%s" -w %s -m %s -c %s -s %s -r %s -o %s' %(self.fileName,self.w,self.m,self.c,self.s,self.r,self.o))
		self.v_end.set("Done!")
		self.label_ending.update_idletasks()
		if os.path.exists("%s/%s.mc"%(self.o1,self.FN)):
			print("using cytoscape to show the interaction network!...\n\n")
			os.system(python+" code/run_cyto.py %s/%s.mc"%(self.o1,self.FN))
		
	def show_run(self):
		self.v_end.set("Running...")
		self.label_ending.update_idletasks()
	def check_run(self):
		# check the inputs
		try:
			if os.path.exists(self.fileName)==False:
				self.v_end.set("Error!: -i Please specify your input sequence file!")
				self.label_ending.update_idletasks()
				return False
		except:
			self.v_end.set("Error!: -i Please specify your input sequence file!")
			self.label_ending.update_idletasks()
			return False
		try:
			int(self.w)
		except:
			self.v_end.set("Error!: -w (The motif length) should be Integer!")
			self.label_ending.update_idletasks()
			return False
		try:
			int(self.m)
		except:
			self.v_end.set("Error!: -m (The number of output motifs) should be Integer!")
			self.label_ending.update_idletasks()
			return False
		try:
			float(self.c)
		except:
			self.v_end.set("Error!: -c (The corrected pvalue cut) should be Float!")
			self.label_ending.update_idletasks()
			return False
		try:
			int(self.s)
		except:
			self.v_end.set("Error!: -s (The frequency cut) should be Integer!")
			self.label_ending.update_idletasks()
			return False
		try:
			int(self.r)
		except:
			self.v_end.set("Error!: -r (The iterations) should be Integer!")
			self.label_ending.update_idletasks()
			return False
		try:
			if os.path.exists(self.o)==False:
				self.o1=self.o
			else:
				self.o1=self.rename_output(self.o)
		except:
			self.v_end.set("Error!: -o The specified output folder name is invalid!")
			self.label_ending.update_idletasks()
			return False
		
		try:
			subprocess.call(["java","-version"])
		except:
			self.v_end.set("Error!: Please install Java Runtime Environment 7 (JRE7)")
			self.label_ending.update_idletasks()
			return False
			
		return True
########################################################################
# root level
def main():
	root=Tk()
	root.geometry("900x500+200+200")
	root.title("SIOMICS")
	########################################################################
	app=App(root)
	root.mainloop()
	########################################################################

if __name__=='__main__':
	main()
